#
#  rpiGPIO.py
#
#  Accepts UDP traffic and turns a pin on or off.
#  DHCP to obtain IP address.
#
#  Written by Daniel Raines Communications on 18/04/2019
#  http://DanielRaines.com | http://BreeCS.com
#

import socket
import sys
import RPi.GPIO as GPIO
import time

GPIO.setmode(GPIO.BCM)
GPIO.setwarnings(False)

sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
sock.bind(('', 9501))

def isINT(val):
  try:
    int(val)
    return True
  except:
    return False

while True:
    data, address = sock.recvfrom(4096)
    if data:
        if "," in data:
            dataArray = data.split(",")
            if len(dataArray) == 4:
                if (dataArray[0] == "StreamDeck"):
                    val = dataArray[1]
                    if (isINT(val)):
                        GPIO.setup(int(val),GPIO.OUT)
                        if (dataArray[2] == "0"):
                            GPIO.output(int(val),GPIO.LOW)
                        elif (dataArray[2] == "1"):
                            GPIO.output(int(val),GPIO.HIGH)
                        elif (dataArray[2] == "2"):
                            GPIO.output(int(val),GPIO.LOW)
                            GPIO.output(int(val),GPIO.HIGH)
                            time.sleep(1)
                            GPIO.output(int(val),GPIO.LOW)



#sudo netstat -ap | grep :9501
#kill -9 <pid>
